{$PACKRECORDS C}

// FreeType 2 API Dynamic/Static linking (Win32,Linux,BeOS,QNX,Solaris)
// Written by Pavel Kanzelsberger (C)2002-2003
// kanzels@boxnetwork.sk, http://www.pixel32.sk

unit freetype;

interface

uses dll;

{$IFDEF Win32}
 {$DEFINE Dynamic}
 const ftlib='freetype.dll';
{$ENDIF}

{$IFDEF Linux}
 {$DEFINE Dynamic}
 const ftlib='/usr/lib/libfreetype.so.6';
{$ENDIF}

{$IFDEF BeOS}
 {$DEFINE Dynamic}
 const ftlib='/boot/home/config/lib/libfreetype.so';
{$ENDIF}

{$IFDEF QNX}
 {$DEFINE Static}
 const ftlib='freetype';
{$ENDIF}

{$IFDEF SunOS}
 {$DEFINE Dynamic}
 const ftlib='/usr/local/lib/libfreetype.so';
{$ENDIF}

type float=single;		// this is fastest, you can use real too

     ft_bool=boolean;
     ft_char=shortint;
     ft_byte=byte;
     ft_string=pchar;
     ft_short=integer;
     ft_ushort=word;
     ft_int=longint;
     ft_uint=dword;
     ft_long=longint;
     ft_ulong=dword;
     ft_fixed=longint;
     ft_pos=longint;
     ft_error=longint;
     ft_pointer=pointer;
     ft_f2dot14=integer;
     ft_f26dot6=longint;
     ft_unitvector=record x,y:ft_f2dot14; end;
     ft_matrix=record xx,xy,yx,yy:ft_fixed; end;
     ft_bbox=record xmin,ymin,xmax,ymax:ft_pos; end;
     ft_vector=record x,y:ft_pos; end;
     ft_encoding=dword;
     ft_glyph_format=dword;
     ft_open_flags=dword;

     ft_glyph_metrics=record width,height:ft_pos;
                             horibearingx,horibearingy:ft_pos;
                             horiadvance:ft_pos;
                             vertbearingx,vertbearingy:ft_pos;
                             vertadvance:ft_pos;
                             end;
     ft_bitmap_size=record width:ft_short;
                           height:ft_short;
                           end;
     ft_bitmap_size_list=array [0..0] of ft_bitmap_size;
     ft_bitmap=record rows:longint;
                      width:longint;
                      pitch:longint;
                      buffer:pointer;
                      num_grays:integer;
                      pixel_mode:byte;
                      palette_mode:byte;
                      palette:pointer;
                      end;
     ft_outline=record n_contours:ft_short;
                       n_points:ft_short;
                       points:^ft_vector;
                       tags:pointer;
                       contours:^ft_short;
                       flags:ft_int;
                       end;
     ft_size_metrics=record x_ppem:ft_ushort;
                            y_ppem:ft_ushort;
                            x_scale:ft_fixed;
                            y_scale:ft_fixed;
                            ascender:ft_pos;
                            descender:ft_pos;
                            height:ft_pos;
                            max_advance:ft_pos;
                            end;
     ft_listnode=^ft_listnoderec;
     ft_listnoderec=record prev:ft_listnode;
                           next:ft_listnode;
                           data:pointer;
                           end;
     ft_listrec=record head:ft_listnode;
                       tail:ft_listnode;
                       end;

     ft_library=pointer;
     ft_module=pointer;
     ft_driver=pointer;
     ft_memory=pointer;
     ft_stream=pointer;
     ft_renderer=pointer;

     ft_face_internal=pointer;
     ft_size_internal=pointer;
     ft_slot_internal=pointer;

     ft_generic=record data:pointer;
                       finalizer:pointer;
                       end;
     ft_glyphslot=^ft_glyphslotrec;
     ft_glyphslotrec=record lib:ft_library;
                            face:pointer; 		// ft_face;
                            next:ft_glyphslot;
                            flags:ft_uint;
                            generic:ft_generic;
                            metrics:ft_glyph_metrics;
                            linearhoriadvance:ft_fixed;
                            linearvertadvance:ft_fixed;
                            advance:ft_vector;
                            format:ft_glyph_format;
                            bitmap:ft_bitmap;
                            bitmap_left:ft_int;
                            bitmap_top:ft_int;
                            outline:ft_outline;
                            num_subglyphs:ft_uint;
                            subglyphs:pointer;
                            control_data:pointer;
                            control_len:longint;
                            other:pointer;
                            internal:ft_slot_internal;
                            end;
     ft_sizerec=record face:pointer;			// ft_face;
                       generic:ft_generic;
                       metrics:ft_size_metrics;
                       internal:ft_size_internal;
                       end;
     ft_size=^ft_sizerec;
     ft_charmaprec=record face:pointer;			// ft_face;
                          encoding:ft_encoding;
                          platform_id:ft_ushort;
                          encoding_id:ft_ushort;
                          end;
     ft_charmap=^ft_charmaprec;
     ft_facerec=record num_faces:ft_long;
                       face_index:ft_long;
                       face_flags:ft_long;
                       style_flags:ft_long;
                       num_glyphs:ft_long;
                       family_name:ft_string;
                       style_name:ft_string;
                       num_fixed_sizes:ft_int;
                       available_sizes:^ft_bitmap_size_list;
                       num_charmaps:ft_int;
                       charmaps:^ft_charmap;
                       generic:ft_generic;
                       bbox:ft_bbox;
                       units_per_em:ft_ushort;
                       ascender:ft_short;
                       descender:ft_short;
                       height:ft_short;
                       max_advance_width:ft_short;
                       max_advance_height:ft_short;
                       underline_position:ft_short;
                       underline_thickness:ft_short;
                       glyph:ft_glyphslot;
                       size:ft_size;
                       charmap:ft_charmap;
                       driver:ft_driver;
                       memory:ft_memory;
                       stream:ft_stream;
                       sizes_list:ft_listrec;
                       auto_hint:ft_generic;
                       extensions:pointer;
                       internal:ft_face_internal;
                       end;

     ft_face=^ft_facerec;

     ft_parameter=record tag:ft_ulong;
                         data:ft_pointer;
                         end;
     ft_open_args=record flags:ft_open_flags;
                         memory_base:^ft_byte;
                         memory_size:ft_long;
                         pathname:pchar;
                         stream:ft_stream;
                         driver:ft_module;
                         num_params:integer;
                         params:^ft_parameter;
                         end;
     
const ft_face_flag_scalable=1;
      ft_face_flag_fixed_sizes=2;
      ft_face_flag_fixed_width=4;
      ft_face_flag_sfnt=8;
      ft_face_flag_horizontal=$10;
      ft_face_flag_vertical=$20;
      ft_face_flag_kerning=$40;
      ft_face_flag_fast_glyphs=$80;
      ft_face_flag_multiple_masters=$100;
      ft_face_flag_glyph_names=$200;
      ft_face_flag_external_stream=$4000;

      ft_style_flag_italic=1;
      ft_style_flag_bold=2;

      ft_open_memory=1;
      ft_open_stream=2;
      ft_open_pathname=4;
      ft_open_driver=8;
      ft_open_params=16;

      ft_load_default=0;
      ft_load_no_scale=1;
      ft_load_no_hinting=2;
      ft_load_render=4;
      ft_load_no_bitmap=8;
      ft_load_vertical_layout=16;
      ft_load_force_autohint=32;
      ft_load_crop_bitmap=64;
      ft_load_pedantic=128;
      ft_load_ignore_global_advance_width=512;
      ft_load_no_recurse=1024;
      ft_load_ignore_transform=2048;
      ft_load_monochrome=4096;
      ft_load_linear_design=8192;

      ft_render_mode_normal=0;
      ft_render_mode_mono=1;

      ft_kerning_default=0;
      ft_kerning_unfitted=1;
      ft_kerning_unscaled=2;

      ft_fix=$10000;

var ft_encoding_none:ft_ulong;
    ft_encoding_symbol:ft_ulong;
    ft_encoding_unicode:ft_ulong;
    ft_encoding_latin_2:ft_ulong;
    ft_encoding_sjis:ft_ulong;
    ft_encoding_gb2312:ft_ulong;
    ft_encoding_big5:ft_ulong;
    ft_encoding_wansung:ft_ulong;
    ft_encoding_johab:ft_ulong;
    ft_encoding_adobe_standard:ft_ulong;
    ft_encoding_adobe_expert:ft_ulong;
    ft_encoding_adobe_custom:ft_ulong;
    ft_encoding_apple_roman:ft_ulong;

    ft_glyph_format_none:ft_ulong;
    ft_glyph_format_composite:ft_ulong;
    ft_glyph_format_bitmap:ft_ulong;
    ft_glyph_format_outline:ft_ulong;
    ft_glyph_format_plotter:ft_ulong;

   {$IFDEF Dynamic}
    ft_lib:longint;

    ft_init_freetype:function (var alibrary:ft_library):ft_error; cdecl;
    ft_done_freetype:function (alibrary:ft_library):ft_error; cdecl;
    ft_new_face:function (alibrary:ft_library;filepathname:pchar;face_index:ft_long;var aface:ft_face):ft_error; cdecl;
    ft_new_memory_face:function (alibrary:ft_library;var file_base:ft_byte;file_size,face_index:ft_long;var aface:ft_face):ft_error; cdecl;
    ft_open_face:function (alibrary:ft_library;var args:ft_open_args;face_index:ft_long;var aface:ft_face):ft_error; cdecl;
    ft_done_face:function (aface:ft_face):ft_error; cdecl;
    ft_set_char_size:function (aface:ft_face;char_width,char_height:ft_f26dot6;horz_resolution,vert_resolution:ft_uint):ft_error; cdecl;
    ft_set_pixel_sizes:function (aface:ft_face;pixel_width,pixel_height:ft_uint):ft_error; cdecl;
    ft_load_glyph:function (aface:ft_face;glyph_index:ft_uint;load_flags:ft_int):ft_error; cdecl;
    ft_load_char:function (aface:ft_face;char_code:ft_ulong;load_flags:ft_int):ft_error; cdecl;
    ft_set_transform:procedure (aface:ft_face;var matrix:ft_matrix;var delta:ft_vector); cdecl;
    ft_render_glyph:function (slot:ft_glyphslot;render_mode:ft_uint):ft_error; cdecl;
    ft_get_kerning:function (aface:ft_face;left_glyph,right_glyph,kern_mode:ft_uint;var akerning:ft_vector):ft_error; cdecl;
    ft_get_glyph_name:function (aface:ft_face;glyph_index:ft_uint;buffer:ft_pointer;buffer_max:ft_uint):ft_error; cdecl;
    ft_select_charmap:function (aface:ft_face;encoding:ft_encoding):ft_error; cdecl;
    ft_set_charmap:function (aface:ft_face;charmap:ft_charmap):ft_error; cdecl;
    ft_get_char_index:function (aface:ft_face;charcode:ft_ulong):ft_uint; cdecl;
    ft_attach_file:function (aface:ft_face;filename:pchar):ft_error; cdecl;
   {$ENDIF}

{$IFDEF Static}
 function ft_init_freetype (var alibrary:ft_library):ft_error; cdecl; external ftlib name 'FT_Init_FreeType';
 function ft_done_freetype (alibrary:ft_library):ft_error; cdecl; external ftlib name 'FT_Done_FreeType';
 function ft_new_face (alibrary:ft_library;filepathname:pchar;face_index:ft_long;var aface:ft_face):ft_error; cdecl; external ftlib name 'FT_New_Face';
 function ft_new_memory_face (alibrary:ft_library;var file_base:ft_byte;file_size,face_index:ft_long;var aface:ft_face):ft_error; cdecl; external ftlib name 'FT_New_Memory_Face';
 function ft_open_face (alibrary:ft_library;var args:ft_open_args;face_index:ft_long;var aface:ft_face):ft_error; cdecl; external ftlib name 'FT_Open_Face';
 function ft_done_face (aface:ft_face):ft_error; cdecl; external ftlib name 'FT_Done_Face';
 function ft_set_char_size (aface:ft_face;char_width,char_height:ft_f26dot6;horz_resolution,vert_resolution:ft_uint):ft_error; cdecl; external ftlib name 'FT_Set_Char_Size';
 function ft_set_pixel_sizes (aface:ft_face;pixel_width,pixel_height:ft_uint):ft_error; cdecl; external ftlib name 'FT_Set_Pixel_Sizes';
 function ft_load_glyph (aface:ft_face;glyph_index:ft_uint;load_flags:ft_int):ft_error; cdecl; external ftlib name 'FT_Load_Glyph';
 function ft_load_char (aface:ft_face;char_code:ft_ulong;load_flags:ft_int):ft_error; cdecl; external ftlib name 'FT_Load_Char';
procedure ft_set_transform (aface:ft_face;var matrix:ft_matrix;var delta:ft_vector); cdecl; external ftlib name 'FT_Set_Transform';
 function ft_render_glyph (slot:ft_glyphslot;render_mode:ft_uint):ft_error; cdecl; external ftlib name 'FT_Render_Glyph';
 function ft_get_kerning (aface:ft_face;left_glyph,right_glyph,kern_mode:ft_uint;var akerning:ft_vector):ft_error; cdecl; external ftlib name 'FT_Get_Kerning';
 function ft_get_glyph_name (aface:ft_face;glyph_index:ft_uint;buffer:ft_pointer;buffer_max:ft_uint):ft_error; cdecl; external ftlib name 'FT_Get_Glyph_Name';
 function ft_select_charmap (aface:ft_face;encoding:ft_encoding):ft_error; cdecl; external ftlib name 'FT_Select_Charmap';
 function ft_set_charmap (aface:ft_face;charmap:ft_charmap):ft_error; cdecl; external ftlib name 'FT_Set_Charmap';
 function ft_get_char_index (aface:ft_face;charcode:ft_ulong):ft_uint; cdecl; external ftlib name 'FT_Get_Char_Index';
 function ft_attach_file (aface:ft_face;filename:pchar):ft_error; cdecl; external ftlib name 'FT_Attach_File';
{$ENDIF}

{$IFDEF Dynamic}
function ft_init:longbool;
function ft_done:longbool;
{$ENDIF}
function ft_make_tag (x1,x2,x3,x4:char):ft_ulong;
function ft_f26dot6_to_int (a:ft_f26dot6):longint;
function ft_f26dot6_to_float (a:ft_f26dot6):float;

implementation

{$IFDEF Dynamic}
function ft_init:longbool;

 function loadsymbol (name:pchar;proc:pointer):longbool;
 var addr:longint;
  begin
  loadsymbol:=false;
  addr:=GetProcAddr (ft_lib,name);
  if addr=0 then exit;
  longint(pointer(ofs(proc^))^):=addr;
  loadsymbol:=true;
  end;

 begin
 ft_init:=false;
 ft_lib:=Load_DLL (ftlib);
 if ft_lib=0 then exit;

 if loadsymbol ('FT_Init_FreeType',@ft_init_freetype)=false then exit;
 if loadsymbol ('FT_Done_FreeType',@ft_done_freetype)=false then exit;
 if loadsymbol ('FT_New_Face',@ft_new_face)=false then exit;
 if loadsymbol ('FT_New_Memory_Face',@ft_new_memory_face)=false then exit;
 if loadsymbol ('FT_Open_Face',@ft_open_face)=false then exit;
 if loadsymbol ('FT_Done_Face',@ft_done_face)=false then exit;
 if loadsymbol ('FT_Set_Char_Size',@ft_set_char_size)=false then exit;
 if loadsymbol ('FT_Set_Pixel_Sizes',@ft_set_pixel_sizes)=false then exit;
 if loadsymbol ('FT_Load_Glyph',@ft_load_glyph)=false then exit;
 if loadsymbol ('FT_Load_Char',@ft_load_char)=false then exit;
 if loadsymbol ('FT_Set_Transform',@ft_set_transform)=false then exit;
 if loadsymbol ('FT_Render_Glyph',@ft_render_glyph)=false then exit;
 if loadsymbol ('FT_Get_Kerning',@ft_get_kerning)=false then exit;
 if loadsymbol ('FT_Get_Glyph_Name',@ft_get_glyph_name)=false then exit;
 if loadsymbol ('FT_Select_Charmap',@ft_select_charmap)=false then exit;
 if loadsymbol ('FT_Set_Charmap',@ft_set_charmap)=false then exit;
 if loadsymbol ('FT_Get_Char_Index',@ft_get_char_index)=false then exit;
 if loadsymbol ('FT_Attach_File',@ft_attach_file)=false then exit;

 ft_init:=true;
 end;
function ft_done:longbool;
 begin
 Free_DLL (ft_lib);
 ft_done:=true;
 end;
{$ENDIF}
function ft_make_tag (x1,x2,x3,x4:char):ft_ulong;
 begin
 ft_make_tag:=(byte(x1) shl 24)+(byte(x2) shl 16)+(byte(x3) shl 8)+byte(x4);
 end;
function ft_f26dot6_to_int (a:ft_f26dot6):longint;
var b:dword;
 begin
 b:=a shr 6;
 if b>=$2000000 then
  ft_f26dot6_to_int:=-($3FFFFFF-b)
   else
  ft_f26dot6_to_int:=b;
 end;
function ft_f26dot6_to_float (a:ft_f26dot6):float;
var b:dword;
    h,l,i:longint;
    d:float;
    
 function num2str (n:longint):string;
 var s:string;
  begin
  str (n,s);
  num2str:=s;
  end;
  
 begin
 b:=a shr 6;
 if b>=$2000000 then h:=-($3FFFFFF-b) else h:=b;
 l:=a and (1+2+4+8+16+32);
 val (num2str(h)+'.'+num2str(l),d,i);
 ft_f26dot6_to_float:=d;
 end;

begin
ft_encoding_symbol:=ft_make_tag ('s','y','m','b');
ft_encoding_unicode:=ft_make_tag ('u','n','i','c');
ft_encoding_latin_2:=ft_make_tag ('l','a','t','2');
ft_encoding_sjis:=ft_make_tag ('s','j','i','s');
ft_encoding_gb2312:=ft_make_tag ('g','b',' ',' ');
ft_encoding_big5:=ft_make_tag ('b','i','g','5');
ft_encoding_wansung:=ft_make_tag ('w','a','n','s');
ft_encoding_johab:=ft_make_tag ('j','o','h','a');
ft_encoding_adobe_standard:=ft_make_tag ('A','D','O','B');
ft_encoding_adobe_expert:=ft_make_tag ('A','D','B','E');
ft_encoding_adobe_custom:=ft_make_tag ('A','D','B','C');
ft_encoding_apple_roman:=ft_make_tag ('a','r','m','n');
ft_glyph_format_composite:=ft_make_tag ('c','o','m','p');
ft_glyph_format_bitmap:=ft_make_tag ('b','i','t','s');
ft_glyph_format_outline:=ft_make_tag ('o','u','t','l');
ft_glyph_format_plotter:=ft_make_tag ('p','l','o','t');
end.
